﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Configuration;
using System.IO;
using Newtonsoft.Json;
using System.Web;
using System.Net;
using log4net;
using System.Web.Script.Serialization;


namespace InvoiceClient
{
    public partial class frmInvoice : Form
    {
        protected static readonly ILog log = LogManager.GetLogger(typeof(frmInvoice));
        string strAccessToken = "";
        string urlAPI = "";
        string codeTax = "";
        string proxy = "";
        int port = 0;
        int ssl = 0;

        public frmInvoice()
        {
            InitializeComponent();
            urlAPI = ConfigurationManager.AppSettings["APILink"].ToString();
            codeTax = ConfigurationManager.AppSettings["CodeTax"].ToString();
            proxy = ConfigurationManager.AppSettings["ProxyIP"].ToString();
            port = int.Parse(ConfigurationManager.AppSettings["ProxyPort"].ToString());
        }
        private void getAccessToken()
        {
            try
            {
                strAccessToken = "";
                string user = ConfigurationManager.AppSettings["User"].ToString();
                string pass = ConfigurationManager.AppSettings["Pass"].ToString();
                string apiLink = urlAPI + @"/auth/login";
                string contentType = "application/json";
                string method = "POST";


                string request = @"{""username"":""" + user + @""",""password"":""" + pass + @"""}";
                if (!chkProxy.Checked)
                {
                    proxy = "";
                    port = 0;
                }
                else
                {
                    if (!string.IsNullOrEmpty(txtProxy.Text) && !string.IsNullOrEmpty(txtPort.Text) && txtProxy.Text != "Địa chỉ Proxy" && txtPort.Text != "Port")
                    {
                        proxy = txtProxy.Text;
                        port = int.Parse(txtPort.Text);
                    }
                }
                ssl = chkSSL.Checked ? 1 : 0;
                string result = CreateRequest.webRequestgetToken(apiLink, request, method, contentType, proxy, port, ssl);

                responseGetAccessToken auth = JsonConvert.DeserializeObject<responseGetAccessToken>(result);
                strAccessToken = @"access_token=" + auth.access_token;
                MessageBox.Show("Đăng nhập thành công");

            }
            catch (Exception ex)
            {
                MessageBox.Show("Có lỗi xảy ra: " + ex.Message);
                //return "";
            }
        }

        private void btnCreateInvoice_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceWS/createInvoice/" + codeTax;
                string contentType = "application/json";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = createInvoiceExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }
                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);
                MessageBox.Show("OK " + result);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }
        private void btnCreateInvoiceDraft_Click(object sender, EventArgs e)
        {
            try
            {

                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceWS/createOrUpdateInvoiceDraft/" + codeTax;
                string contentType = "application/json";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = createInvoiceDraftExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }
                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);
                MessageBox.Show("OK " + result);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }
        private void btnCancel_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceWS/cancelTransactionInvoice";
                string contentType = "application/x-www-form-urlencoded";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = cancelInvoiceExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }

                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);

                MessageBox.Show("OK " + result);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }
        private void btnSavePDF_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceUtilsWS/getInvoiceRepresentationFile";
                string contentType = "application/json";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = getPDFExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }

                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);
                
                PDFFileResponse objFile = JsonConvert.DeserializeObject<PDFFileResponse>(result);
                string fileName = objFile.fileName;
                string path = Path.Combine(Application.StartupPath, "pdfFile") + "\\" + fileName + ".pdf";
                File.WriteAllBytes(path, objFile.fileToBytes);

                MessageBox.Show("File in " + path);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }
        private void btnGetInvoice_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceUtilsWS/getListInvoiceDataControl";
                string contentType = "application/json";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = getInvoiceExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }

                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);

                MessageBox.Show("OK  " + result);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }

        private void btnUpdatePaymentStatus_Click(object sender, EventArgs e)
        {
            try
            {
                if (string.IsNullOrEmpty(strAccessToken))
                {
                    MessageBox.Show("Chưa lấy giá tị Token");
                    return;
                }
                string apiLink = urlAPI + @"/services/einvoiceapplication/api/InvoiceAPI/InvoiceWS/updatePaymentStatus";
                string contentType = "application/x-www-form-urlencoded";

                int chk = chkExample.Checked ? 1 : 0;
                string request = "";

                if (chk == 1)
                {
                    request = updatePaymetStatusExample();
                }
                else
                {
                    request = txtBody.Text;
                    if (string.IsNullOrEmpty(request))
                    {
                        MessageBox.Show("Chưa nhập giá trị text của body");
                        return;
                    }
                }
                string result = CreateRequest.webRequestV2(apiLink, request, strAccessToken, "POST", contentType, proxy, port, ssl);
                MessageBox.Show("OK " + result);
            }
            catch (Exception ex)
            {
                MessageBox.Show("NOK " + ex.Message);
            }
        }

        private void btnGetAccessToken_Click(object sender, EventArgs e)
        {
            getAccessToken();
        }
        private string createInvoiceExample()
        {
            string str = @"{
   ""generalInvoiceInfo"": {
      ""invoiceType"": ""01GTKT"",
      ""templateCode"": ""01GTKT0/002"",
      ""invoiceSeries"": ""AA/20E"",
      ""currencyCode"": ""VND"",
      ""invoiceIssuedDate"": """ + ((Int64)(DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1))).TotalMilliseconds).ToString() + @""",
      ""adjustmentType"": ""1"",
      ""paymentStatus"": true,
      ""paymentType"": ""CK"",
      ""paymentTypeName"": ""CK"",
      ""cusGetInvoiceRight"": true,
      ""userName"": ""test2"",
      ""transactionUuid"":""" + System.Guid.NewGuid().ToString() + @"""
   },
   ""buyerInfo"": {
      ""buyerName"": ""Lê Thị Thanh Minh_có mã KH_import CoopSmile"",
      ""buyerLegalName"": ""Tên đơn vị"",
      ""buyerTaxCode"": ""8008675383"",
      ""buyerAddressLine"": ""An Khánh Hoài Đức Hà Nội"",
      ""buyerPostalCode"": ""2342324323"",
      ""buyerDistrictName"": ""Số 9, đường 11, VSIP Bắc Ninh, Thị xã Từ Sơn, Tỉnh"",
      ""buyerCityName"": ""Thành Phố Hà Nội"",
      ""buyerCountryCode"": ""84"",
      ""buyerPhoneNumber"": ""987999999"",
      ""buyerFaxNumber"": ""0458954"",
      ""buyerEmail"": ""tamdtt1@viettel.com.vn"",
      ""buyerBankName"": ""Ngân hàng Quân đội MB"",
      ""buyerBankAccount"": ""01578987871236547"",
      ""buyerIdNo"": ""8888899999"",
      ""buyerIdType"": ""3"",
      ""buyerCode"": ""832472343b_b"",
      ""buyerBirthDay"": """"
   },
   ""sellerInfo"": {
      ""sellerCode"": ""MaCNbenban"",
      ""sellerLegalName"": ""TẬP ĐOÀN VIỄN THÔNG QUÂN ĐỘI"",
      ""sellerTaxCode"": ""0100109106-712"",
      ""sellerAddressLine"": ""Số 21 Cát Linh, phường Cát Linh - Quận Ba Đình - Thành Phố Hà Nội - Việt Nam"",
      ""sellerPhoneNumber"": ""57896512"",
      ""sellerEmail"": ""hieuvtm@viettel.com.vn"",
      ""sellerBankName"": ""Ngân hàng Quân Đội MB - CN huyện Yên Sơn; Ngân hàng Vietinbank"",
      ""sellerBankAccount"": ""012564654654; 010057839922""
   },
   ""extAttribute"": [],
   ""payments"": [
      {
         ""paymentMethodName"": ""CK""
      }
   ],
   ""deliveryInfo"": {},
   ""itemInfo"": [
      {
         ""lineNumber"": 1,
         ""itemCode"": ""Thue0"",
         ""itemName"": ""Có tính thuế"",
         ""unitName"": ""KG"",
         ""unitPrice"": 100000,
         ""quantity"": 1,
         ""itemTotalAmountWithoutTax"": 100000,
         ""itemTotalAmountWithTax"": 100000,
         ""itemTotalAmountAfterDiscount"": 100000,
         ""taxPercentage"": 0,
         ""taxAmount"": 0,
         ""discount"": 0,
         ""itemDiscount"": 0,
         ""itemNote"": """",
         ""batchNo"": """",
         ""expDate"": """"
      }
   ],
   ""discountItemInfo"": [],
   ""summarizeInfo"": {
      ""sumOfTotalLineAmountWithoutTax"": 100000,
      ""totalAmountWithoutTax"": 100000,
      ""totalTaxAmount"": 10000,
      ""totalAmountWithTax"": 110000,
      ""totalAmountAfterDiscount"": 110000,
      ""totalAmountWithTaxInWords"": ""Mười hai triệu ba trăm hai mươi bảy nghìn sáu trăm tám mươi mốt phẩy  chín đồng"",
      ""discountAmount"": 0
   },
   ""taxBreakdowns"": [
      {
         ""taxPercentage"": 10,
         ""taxableAmount"": 100000,
         ""taxAmount"": 10000
      }
   ],
   ""metadata"": [],
   ""customFields"": [],
   ""meterReading"": [],
   ""invoiceFile"": {
            ""fileContent"": ""RmlsZSBi4bqjbmcga8OqIMSRxrDhu6NjIGFkZCBsw6puIHThuqFpIHBo4bqnbiBs4bqtcCBow7NhIMSRxqFu"",
            ""fileType"": ""1""
          }
}";

            return str;
        }
        private string createInvoiceDraftExample()
        {
            string str = @"{
   ""generalInvoiceInfo"": {
      ""invoiceType"": ""01GTKT"",
      ""templateCode"": ""01GTKT0/002"",
      ""invoiceSeries"": ""AA/20E"",
      ""currencyCode"": ""VND"",
      ""invoiceIssuedDate"": """ + ((Int64)(DateTime.UtcNow.Subtract(new DateTime(1970, 1, 1))).TotalMilliseconds).ToString() + @""",
      ""adjustmentType"": ""1"",
      ""paymentStatus"": true,
      ""paymentType"": ""CK"",
      ""paymentTypeName"": ""CK"",
      ""cusGetInvoiceRight"": true,
      ""userName"": ""test2"",
      ""transactionUuid"":""" + System.Guid.NewGuid().ToString() + @"""
   },
   ""buyerInfo"": {
      ""buyerName"": ""Lê Thị Thanh Minh_có mã KH_import CoopSmile"",
      ""buyerLegalName"": ""Tên đơn vị"",
      ""buyerTaxCode"": ""8008675383"",
      ""buyerAddressLine"": ""An Khánh Hoài Đức Hà Nội"",
      ""buyerPostalCode"": ""2342324323"",
      ""buyerDistrictName"": ""Số 9, đường 11, VSIP Bắc Ninh, Thị xã Từ Sơn, Tỉnh"",
      ""buyerCityName"": ""Thành Phố Hà Nội"",
      ""buyerCountryCode"": ""84"",
      ""buyerPhoneNumber"": ""987999999"",
      ""buyerFaxNumber"": ""0458954"",
      ""buyerEmail"": ""tamdtt1@viettel.com.vn"",
      ""buyerBankName"": ""Ngân hàng Quân đội MB"",
      ""buyerBankAccount"": ""01578987871236547"",
      ""buyerIdNo"": ""8888899999"",
      ""buyerIdType"": ""3"",
      ""buyerCode"": ""832472343b_b"",
      ""buyerBirthDay"": """"
   },
   ""sellerInfo"": {
      ""sellerCode"": ""MaCNbenban"",
      ""sellerLegalName"": ""TẬP ĐOÀN VIỄN THÔNG QUÂN ĐỘI"",
      ""sellerTaxCode"": ""0100109106-712"",
      ""sellerAddressLine"": ""Số 21 Cát Linh, phường Cát Linh - Quận Ba Đình - Thành Phố Hà Nội - Việt Nam"",
      ""sellerPhoneNumber"": ""57896512"",
      ""sellerEmail"": ""hieuvtm@viettel.com.vn"",
      ""sellerBankName"": ""Ngân hàng Quân Đội MB - CN huyện Yên Sơn; Ngân hàng Vietinbank"",
      ""sellerBankAccount"": ""012564654654; 010057839922""
   },
   ""extAttribute"": [],
   ""payments"": [
      {
         ""paymentMethodName"": ""CK""
      }
   ],
   ""deliveryInfo"": {},
   ""itemInfo"": [
      {
         ""lineNumber"": 1,
         ""itemCode"": ""Thue0"",
         ""itemName"": ""Có tính thuế"",
         ""unitName"": ""KG"",
         ""unitPrice"": 100000,
         ""quantity"": 1,
         ""itemTotalAmountWithoutTax"": 100000,
         ""itemTotalAmountWithTax"": 100000,
         ""itemTotalAmountAfterDiscount"": 100000,
         ""taxPercentage"": 0,
         ""taxAmount"": 0,
         ""discount"": 0,
         ""itemDiscount"": 0,
         ""itemNote"": """",
         ""batchNo"": """",
         ""expDate"": """"
      }
   ],
   ""discountItemInfo"": [],
   ""summarizeInfo"": {
      ""sumOfTotalLineAmountWithoutTax"": 100000,
      ""totalAmountWithoutTax"": 100000,
      ""totalTaxAmount"": 10000,
      ""totalAmountWithTax"": 110000,
      ""totalAmountAfterDiscount"": 110000,
      ""totalAmountWithTaxInWords"": ""Mười hai triệu ba trăm hai mươi bảy nghìn sáu trăm tám mươi mốt phẩy  chín đồng"",
      ""discountAmount"": 0
   },
   ""taxBreakdowns"": [
      {
         ""taxPercentage"": 10,
         ""taxableAmount"": 100000,
         ""taxAmount"": 10000
      }
   ],
   ""metadata"": [],
   ""customFields"": [],
   ""meterReading"": [],
   ""invoiceFile"": {
            ""fileContent"": ""RmlsZSBi4bqjbmcga8OqIMSRxrDhu6NjIGFkZCBsw6puIHThuqFpIHBo4bqnbiBs4bqtcCBow7NhIMSRxqFu"",
            ""fileType"": ""1""
          }
}";

            return str;
        }
        private string cancelInvoiceExample()
        {
            string str = @"supplierTaxCode=0100109106-712&invoiceNo=AA%2F20E0000001&strIssueDate=1600102800000&additionalReferenceDesc=hello&additionalReferenceDate=1600230649604";

            return str;
        }
        private string getPDFExample()
        {
            string str = @"{
                ""supplierTaxCode"":""0100109106-712"",
                ""invoiceNo"":""AA/20E0000003"",
                ""templateCode"":""01GTKT0/002"",
                ""fileType"":""PDF""
            }";

            return str;
        }
        private string getInvoiceExample()
        {
            string str = @"{
	            ""supplierTaxCode"":""0100109106-712"",
	            ""fromDate"":""01/08/2020"",
	            ""toDate"":""18/09/2020""
            }";

            return str;
        }
        private string updatePaymetStatusExample()
        {
            string str = @"supplierTaxCode=0100109106-712&invoiceNo=AA%2F20E0000002&strIssueDate=1600154781000&templateCode=01GTKT0%2F002&buyerEmailAddress=tamdtt1%40viettel.com.vn&paymentType=TM&paymentTypeName=TM&cusGetInvoiceRight=true";

            return str;
        }
        private void txtProxy_Enter(object sender, EventArgs e)
        {
            if (txtProxy.Text == "Địa chỉ Proxy")
            {
                txtProxy.Text = "";
                txtProxy.ForeColor = System.Drawing.Color.Black;
            }
        }
        private void txtProxy_Leave(object sender, EventArgs e)
        {

            if (txtProxy.Text == "")
            {
                txtProxy.Text = "Địa chỉ Proxy";
                txtProxy.ForeColor = System.Drawing.Color.LightGray;
            }
        }
        private void txtPort_Enter(object sender, EventArgs e)
        {
            if (txtPort.Text == "Port")
            {
                txtPort.Text = "";
                txtPort.ForeColor = System.Drawing.Color.Black;
            }
        }
        private void txtPort_Leave(object sender, EventArgs e)
        {

            if (txtPort.Text == "")
            {
                txtPort.Text = "Port";
                txtPort.ForeColor = System.Drawing.Color.LightGray;
            }
        }
        private void chkProxy_CheckedChanged(object sender, EventArgs e)
        {
            if (chkProxy.Checked)
            {
                txtProxy.Visible = true;
                txtPort.Visible = true;

                txtProxy.Text = "Địa chỉ Proxy";
                txtProxy.ForeColor = System.Drawing.Color.LightGray;

                txtPort.Text = "Port";
                txtPort.ForeColor = System.Drawing.Color.LightGray;
            }
            else
            {
                txtProxy.Visible = false;
                txtPort.Visible = false;
            }
        }        
    }
}
